interface SelectOptions {
    force?: boolean;
    collapse?: 'start' | 'end' | false;
}
type SelectOffsets = readonly [number, number] | number | true;

type Replacer = Parameters<typeof String.prototype.replace>[1];
interface HighlightRule {
    pattern: RegExp | string;
    class?: string;
    tagName?: string;
    style?: string;
    replacer?: Replacer;
}
interface SetupOptions {
    defaultValue?: string;
    highlight: HighlightRule | Array<HighlightRule> | ((value: string) => string);
    patch?: (el: HTMLElement, html: string) => void;
    onInput?: (event: {
        value: string;
        position: number;
    }) => void;
}
type HighlightableInput = ReturnType<typeof setup>;
declare function setup(el: HTMLElement, { defaultValue, onInput, highlight, patch }: SetupOptions): {
    getValue(): string;
    setValue(value: string): boolean;
    setSelection(offsets: SelectOffsets, options?: SelectOptions): void;
    getSelection(): readonly [number, number];
    valueToRawHTML(value: string): string;
    dispose: () => void;
    refresh(): void;
};

export { HighlightRule, HighlightableInput, SetupOptions, setup };
