import { HTMLAttributes } from 'react';
import { SetupOptions } from './index.js';

declare global {
    namespace JSX {
        interface IntrinsicElements {
            'highlightable-input': any;
        }
    }
}
type HighlightableInputProps = {
    defaultValue?: string;
    value?: string;
    multiline?: boolean;
    readonly?: boolean;
    disabled?: boolean;
    theme?: string;
    highlight: SetupOptions['highlight'];
    patch?: SetupOptions['patch'];
    onChange?: (text: string) => void;
} & Omit<HTMLAttributes<HTMLElement>, 'onChange'>;
declare const Component: {
    (props: HighlightableInputProps): JSX.Element;
    displayName: string;
};

export { Component as default };
